package de.jatitv.papitest.commands;

import de.jatitv.papitest.Util;
import de.jatitv.papitest.config.Config;
import de.jatitv.papitest.system.Main;
import me.clip.placeholderapi.PlaceholderAPI;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2CmcVersion;
import net.t2code.t2codelib.SPIGOT.api.plugins.T2CpluginCheck;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public class Commands {
    protected static void info(CommandSender sender) {
        T2Ctemplate.sendInfo(sender,Main.getPlugin(),Util.getSpigotID(),Util.getDiscord(),Util.getInfoText());
    }

    protected static void reload(CommandSender sender) {
        try {
            Reload.reload(sender);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    protected static void use(CommandSender sender, String[] args) {
        if (!T2CpluginCheck.papi()) {
            Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§4\n" + Util.getPrefix() + " §4PlaceholderAPI could not be connected / found! " +
                    "§9Please download it here: §6https://www.spigotmc.org/resources/placeholderapi.6245/§4\n" + Util.getPrefix());
            if (sender instanceof Player) {
                sender.sendMessage(Util.getPrefix() + "§4\n" + Util.getPrefix() + " §4PlaceholderAPI could not be connected / found! §9Please download it here: " +
                        "§6https://www.spigotmc.org/resources/placeholderapi.6245/§4\n" + Util.getPrefix());
            }
            return;

        }
        List<String> results = Arrays.stream(args).filter(a -> a.contains("-p:")).collect(Collectors.toList());
        CommandSender executor;
        if(results.size() == 0){
            executor = sender;
        }else {
            String targetSt = results.get(0).replace("-p:","");
            Player target = Bukkit.getPlayer(targetSt);
            if (target == null) {
                sender.sendMessage(Util.getPrefix()+ " §4Player §6" + targetSt + " §4is not Online!");
                return;
            }
            executor = target;
        }
        if(executor instanceof Player){
            execute(sender,(Player)executor, args[0]);
        }else {
            sender.sendMessage(Util.getPrefix() + " §4If you want to execute the command via console, then you have to write §6-p:<player> §4to it, as which player you want to query the placeholder."); //todo
        }
    }
    protected static void execute(CommandSender sender, Player target, String placeholder) {

        sender.sendMessage(Util.getPrefix() + " §b" + placeholder + " §7-> " + "§6" + PlaceholderAPI.setPlaceholders(target, placeholder));
        if (!T2CmcVersion.isMc1_8() && Config.Titel && sender instanceof Player) {
            ((Player)sender).sendTitle("§5PaPi§6Test§8: " + "§b" + placeholder, "§6" + PlaceholderAPI.setPlaceholders(target, placeholder));
        }
    }
}
